/*
 * BEGIN FLOCK GPL
 * 
 * Copyright Flock Inc. 2005-2006
 * http://flock.com
 * 
 * This file may be used under the terms of of the
 * GNU General Public License Version 2 or later (the "GPL"),
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 * 
 * END FLOCK GPL
 */

function hex_md5_stream(stream)
{
    var hasher = Components.classes["@mozilla.org/security/hash;1"]
        .createInstance(Components.interfaces.nsICryptoHash);
    hasher.init(hasher.MD5);

    hasher.updateFromStream(stream, stream.available());
    var hash = hasher.finish(false);

    var ret = '';
    for (var i = 0; i < hash.length; ++i) {
        var hexChar = hash.charCodeAt(i).toString(16);
        if (hexChar.length == 1)
            ret += '0';
        ret += hexChar;
    }

    return ret;
}

function hex_md5(s)
{
    var stream = Components.classes["@mozilla.org/io/string-input-stream;1"]
        .createInstance(Components.interfaces.nsIStringInputStream);
    stream.setData(s, s.length);

    return hex_md5_stream(stream);
}
